#
# spec file for package mod_php4 (Version 4.0.6)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  aolserver apache apache-devel bzip compat curl curl-devel cyrus-sasl expat freetype2 gd gd-devel gdbm gettext glib-devel gmp gpp gtk-devel imap imap-devel jakarta java libgpp libjpeg libmcal libmcrypt libmcrypt-devel libpng libtiff libxml2 libxml2-devel libz lynx mm mod_dav mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel openssl openssl-devel orbit orbit-devel postgresql-devel postgresql-libs qtdevel qtlib readline readline-devel recode recode-devel sablot sablot-devel t1lib t1lib-devel ucdsnmp xf86 zip
# usedforbuild    aaa_base aaa_dir base bash bindutil bison bzip compress cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim aolserver apache apache-devel autoconf automake binutils compat cracklib curl curl-devel expat freetype2 gcc gd gd-devel gdbm gettext glib-devel gmp gpp gtk-devel imap imap-devel jakarta java libgpp libjpeg libmcal libmcrypt libmcrypt-devel libpng libtiff libtool libxml2 libxml2-devel libz lynx mm mod_dav mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel openssl openssl-devel orbit orbit-devel pam perl postgresql-devel postgresql-libs qtcompat qtdevel qtlib readline-devel recode recode-devel rpm sablot sablot-devel t1lib t1lib-devel ucdsnmp xdevel xf86 xshared zip

Name:         mod_php4
%define apache_mmn        %(MMN=$(apxs -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define apache_serverroot %(apxs -q PREFIX)
%define java_jdkdir       %(find %{_libdir} -type d -name jdk\* -o -type d -name j2sdk\* -o -name kaffe -maxdepth 1 | sort | head -1)
%define java_incdir       %(dirname `find %{java_jdkdir} -name jni.h |grep -v include-old`)
%define qtdom_dir         %(find %{_libdir} -type d -name qt\* -maxdepth 1)
Version:      4.0.6
Release:      193
Copyright:    the PHP project
Group:        Networking/Daemons
Provides:     php php4 mod_php4 zend mod_php
Requires:     apache  %{apache_mmn}
Requires:     %{name}-core = %{version}-%{release}
Conflicts:    midgard
Obsoletes:    mod_php
Autoreqprov:  on
Source0:      ftp://ftp.php.net/pub/version4/downloads/php-%{version}.tar.bz2
Source2:      http://reality.sgi.com/grafica/flash/dist.99.linux.tar.bz2
Source3:      asp2php-0.75.14.tar.bz2
Patch0:       php-%{version}.dif
Patch1:       ftp://ftp.php.net/pub/version4/downloads/php-4.0.6-memlimit.diff.gz
Patch2:       php-%{version}-security.patch
Patch3:       php-%{version}-mail.diff
Patch4:       php-%{version}-mm.diff
Patch5:       php-%{version}-url.diff
Url:          http://www.php4.net/
Icon:         php4.xpm
Summary:      Latest version of the HTML embedded scripting language
%package aolserver
Summary:      PHP4 for the AOL server
Group:        Networking/Daemons
Requires:     aolserver 
Requires:     %{name}-core = %{version}-%{release}
%package core
Summary:      core files of PHP4
Group:        Networking/Daemons
%package servlet
Summary:      PHP4 as a Jakarta servlet
Group:        Networking/Daemons
Requires:     jakarta
Requires:     %{name}-core = %{version}-%{release}
%prep
%setup -n php-%{version}
%setup -n php-%{version} -c php-%{version} -a 2 -a 3 -T -D
%ifarch s390
%suse_update_config;
%endif
%patch
zcat $RPM_SOURCE_DIR/php-4.0.6-memlimit.diff.gz | patch Zend/zend_alloc.c
%patch2 -p1
%patch3
%patch4
%patch5
%ifarch i386
mkdir -p dist/include/
mkdir -p dist/lib/
mv dist/*.h dist/include/
mv dist/*.a dist/lib/
%endif

%build
#autoconf ;
#automake ;

%install
%ifarch alpha
export CLASSPATH=%{java_jdkdir}/lib/tools.jar:%{java_jdkdir}/lib/classes.zip:$CL
%else
export CLASSPATH=%{java_jdkdir}/lib/classes.zip:$CLASSPATH
%endif
PATH=$PATH:/usr/lib/kaffe/bin/
exportJAVA_JAR=`which jar`
DYNAMIC_MODULES=""
if [ -e %{_libdir}/libssl.so.0 ] ; then
	DYNAMIC_MODULES="$DYNAMIC_MODULES --with-openssl"
fi
if [ -e %{_bindir}/curl-config ] ; then
    DYNAMIC_MODULES="$DYNAMIC_MODULES --with-curl"
fi
%ifarch i386
	DYNAMIC_MODULES="$DYNAMIC_MODULES --with-swf=./dist/"
%endif
%ifnarch ppc
	DYNAMIC_MODULES="$DYNAMIC_MODULES --with-imap-ssl"
%endif
%ifarch s390
	DYNAMIC_MODULES="$DYNAMIC_MODULES --with-gd=shared"
%else
	DYNAMIC_MODULES="$DYNAMIC_MODULES --with-gd=yes"
%endif
#
# Loop over the supported web servers (core Apache Roxen Java-Servlet)
#
cat configure | sed -e "s+lib/php+php+g" > configure.new
mv configure.new configure
chmod 755 configure
rm -f ./.status
for Servers in core apache servlet aol ; do
	case "$Servers" in
		aol)
			SERVER_TOGGLES="--with-aolserver=/opt/aolserver/ --with-pgsql=%{_usr} --with-snmp"
		;;
		core)
			SERVER_TOGGLES="--with-pgsql=%{_usr} --with-snmp"
		;;
		apache)
        		SERVER_TOGGLES="--with-apxs=`which apxs` --with-pgsql=%{_usr} --with-snmp"
		;;
		servlet)
                        SERVER_TOGGLES="--with-servlet=/opt/jakarta/ --with-pgsql=%{_usr} --with-snmp"
		;;
	esac
	echo "$Servers" >> ./.status
	rm -f config.cache ;
	CFLAGS="$RPM_OPT_FLAGS -fPIC -DHAVE_LIBDL=1 -I/usr/include/ucd-snmp -I/usr/include/gd -I%{java_jdkdir}/include/linux -I%{java_incdir}"  \
		LDFLAGS="" EXTRA_LIBS="-L/usr/X11R6/lib/ -lpng -lXpm -lncurses -lpam -lssl" \
		./configure \
		--prefix=%{_datadir} \
		--datadir=%{_datadir}/php \
		--bindir=%{_bindir} \
		--libdir=%{_datadir} \
		--with-config-file-path=/etc \
		--with-exec-dir=%{_libdir}/php/bin \
		--with-mysql=%{_usr} \
%ifarch s390
		--with-gd=shared \
%else
		--with-gd=yes \
%endif
		--enable-gd-native-ttf \
		--enable-gd-imgstrttf \
		--with-tiff-dir=%{_usr} \
		--with-jpeg-dir=%{_usr} \
		--with-png-dir=%{_usr} \
		--with-xpm-dir=/usr/X11R6 \
		--with-ldap=yes \
		--with-zlib=yes \
		--with-bz2 \
		--with-gmp \
		--with-xml \
		--with-dom \
		--with-ttf \
		--with-t1lib \
		--with-mcal=%{_usr} \
		--with-imap=yes \
		--with-sablot \
		--with-readline \
		--with-ftp \
		--with-ndbm \
		--with-gdbm \
		--with-mcrypt \
		--with-gettext \
		--with-mm \
		--with-gd=yes \
		--with-qtdom=%{qtdom_dir} \
		--enable-versioning \
		--enable-yp \
		--enable-bcmath \
		--enable-trans-sid \
		--enable-inline-optimization \
		--enable-track-vars \
		--enable-magic-quotes \
		--enable-safe-mode \
		--enable-sockets \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-shmop \
		--enable-calendar \
		--enable-mbstring \
		--enable-mbstr-enc-trans \
		--enable-exif \
		--enable-ftp \
		--enable-memory-limit \
		--enable-wddx \
		--enable-filepro \
		--enable-dbase \
		--enable-ctype \
		--disable-debug \
		--enable-force-cgi-redirect \
		--enable-discard-path \
		--enable-sigchild \
        	$DYNAMIC_MODULES $SERVER_TOGGLES %{_target_cpu}-suse-linux ; 
	echo "JAVA_JAR = `which jar` cf" >> build/ltlib.mk
	make ;
	make install ;
	make clean ;
done ;
mv %{_datadir}/phpsrvlt.jar /opt/jakarta/lib/
mv %{_datadir}/libphp4.so   /opt/jakarta/lib/
# options which dont work yet, but should be activated ASAP:
#
# --enable-satellite --with-mod-dav=%{apache_includedir} 
# --with-kerberos[=DIR]  --with-recode=/usr/include/ --with-crack 
echo -e "Variable:HTTPD_SEC_MOD_PHP\nLoadModule:LoadModule php4_module %{apache_libexecdir}/libphp4.so\nAddModule:AddModule mod_php4.c\nText:PHP4\n" \
        > %{apache_sysconfdir}/modules/mod_php4
install -m 644 apache.rc.config %{_var}/adm/fillup-templates/apache-mod_php4.rc.config
cp -av php.ini-dist /etc/php.ini
mkdir -p %{apache_libexecdir}/bin ;
pushd asp2php-0.75.14 ;
	make all gtkasp2php unipiss ;
	strip asp2php unipiss gtkasp2php
	install -m 755 asp2php %{_bindir} ;
	install -m 755 unipiss %{_bindir} ;
	install -m 755 gtkasp2php /usr/X11R6/bin/ ;
popd ;
strip %{apache_libexecdir}/libphp4.so ;
strip /opt/jakarta/lib/libphp4.so ;
strip /opt/aolserver/bin/libphp4.so ;
strip %{_bindir}/php ;
%{_bindir}/php test.php > /dev/null || exit 1
%{_bindir}/php test.php | lynx --dump > README.ENABLED_FEATURES
echo -e "LoadModule php4_module %{apache_libexecdir}/libphp4.so\n" > %{apache_sysconfdir}/suse_loadmodule.conf
echo -e "AddModule mod_php4.c\n" > %{apache_sysconfdir}/suse_addmodule.conf
httpd -t || exit 1

%files
%defattr(-, root, root)
%{apache_libexecdir}/libphp4.so
%{_var}/adm/fillup-templates/apache-mod_php4.rc.config
%{apache_sysconfdir}/modules/mod_php4

%post
echo -n "Updating etc/rc.config.d/apache.rc.config..."
if [ -x bin/fillup ] ; then
        test -e etc/rc.config.d/apache.rc.config || touch etc/rc.config.d/apache.rc.config
        bin/fillup -q -d = etc/rc.config.d/apache.rc.config var/adm/fillup-templates/apache-mod_php4.rc.config
        echo " Done."
else
        echo
        echo "ERROR: fillup not found. This should not happen. Please compare"
        echo "etc/rc.config.d/apache.rc.config and "
	echo "var/adm/fillup-templates/apache-mod_php4.rc.config and update by hand."
fi

%files aolserver
%defattr(-, root, root)
%doc sapi/aolserver/README
/opt/aolserver/bin/libphp4.so

%files servlet
%defattr(-, root, root)
%doc sapi/servlet/web.xml sapi/servlet/README
/opt/jakarta/lib/phpsrvlt.jar
/opt/jakarta/lib/libphp4.so

%files core
%defattr(-, root, root)
%doc READ* CODING_STANDARDS CREDITS 
%doc INSTALL 
%doc LICENSE NEWS TOD* 
%doc test.php
%{_datadir}/php/
%config /etc/php.ini
%{_bindir}/phpextdist
%{_bindir}/php
%{_bindir}/phpize 
%{_bindir}/php-config 
%{_bindir}/pear
%{_bindir}/asp2php
%{_bindir}/unipiss
/usr/X11R6/bin/gtkasp2php

%description
PHP is a server-side, cross-platform, HTML embedded scripting
language. If you are completely new to PHP and want to get some idea
of how it works, have a look at the Introductory Tutorial.  Once you
get beyond that have a look at the example archive sites and some of
the other resources available in the Links section.
PHP4 is the latest version.

Authors:
--------
    Andrei Zmievski <andrei@ispi.net>
    Danny Heijl <Danny.Heijl@cevi.be>
    Frank M. Kromann <fmk@swwwing.com>
    Rasmus Lerdorf <rasmus@php.net>
    Sam Ruby <rubys@us.ibm.com>
    Sascha Schumann <sascha@schumann.cx>
    Stefan Roehrich <sr@linux.de>
    Thies C. Arntzen <thies@digicol.de>
    Uwe Steinmann <steinm@php.net>

SuSE series: n


%description servlet
PHP is a server-side, cross-platform, HTML embedded scripting
language. If you are completely new to PHP and want to get some idea
of how it works, have a look at the Introductory Tutorial.  Once you
get beyond that, have a look at the example archive sites and some of
the other resources available in the Links section.
PHP4 is the latest version.

SuSE series: n


%description aolserver
PHP is a server-side, cross-platform, HTML embedded scripting
language. If you are completely new to PHP and want to get some idea
of how it works, have a look at the Introductory Tutorial.  Once you
get beyond that, have a look at the example archive sites and some of
the other resources available in the Links section.
PHP4 is the latest version.

Authors:
--------
        Andrei Zmievski <andrei@ispi.net>
        Danny Heijl <Danny.Heijl@cevi.be>
        Frank M. Kromann <fmk@swwwing.com>
        Rasmus Lerdorf <rasmus@php.net>
        Sam Ruby <rubys@us.ibm.com>
        Sascha Schumann <sascha@schumann.cx>
        Stefan Roehrich <sr@linux.de>
        Thies C. Arntzen <thies@digicol.de>
        Uwe Steinmann <steinm@php.net>

SuSE series: n


%description core
This package contains the core files of PHP4. Additionally the modules
for certain webservers like Apache or Roxen may be installed.

SuSE series: n


%changelog -n mod_php4
* Thu Sep 19 2002 - tcrhak@suse.cz
- fix of module mm (session path name) - enable different users
  use php (patch *-mm.diff) [bug #17312]
- security fix of php function mail (patch *-mail.diff)
- security fix of CRLF injection bug (patch *-url.diff)
* Sat Jul 20 2002 - poeml@suse.de
- detect the module magic number if provided by apache, indicating
  API changes, and add an RPM Require on it
* Wed Feb 27 2002 - okir@suse.de
- security fix
* Tue Sep 11 2001 - ro@suse.de
- remove roxen subpackage
  roxen is not in the distribution currently
* Wed Aug 22 2001 - ro@suse.de
- removed pdflib from neededforbuild (license problems)
* Tue Aug 14 2001 - ro@suse.de
- pear: changed header to look for php in "bindir" not "prefix/bin"
  to fix requires
* Mon Aug 13 2001 - kukuk@suse.de
- Don't conflict with packages we are providing
* Thu Aug 09 2001 - kukuk@suse.de
- Fix search for installed java directory
* Tue Jul 24 2001 - rolf@suse.de
- new subpackage mod_php4-aolserver for use of PHP4 with AOL server
- disable-debug so Zend optimizer can work
* Thu Jul 05 2001 - rolf@suse.de
- update to php 4.0.6
- apply memlimit patch
- new subpackage mod_php4-servlet for use of PHP4 as JAVA servlet
  with tomcat
- new options: --with-gmp, --with-dom, mbstring
* Mon Jun 25 2001 - rolf@suse.de
- fixed bug with pdflib which also fixes [BUG#8246]
* Tue Jun 19 2001 - rolf@suse.de
- new version 4.0.5
- disable pgsql for roxen, as it is broken
- mysql bug fixed in this release [BUG#6839]
- move stuff to /usr/share/php [BUG#8352]
- now Provides: mod_php as well [BUG#8911]
* Sat May 12 2001 - schwab@suse.de
- Use new readline interface.
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Tue May 01 2001 - kukuk@suse.de
- disable adabas support
* Thu Apr 26 2001 - ro@suse.de
- neededforbuild: curl_ssl-devel -> curl-devel
* Sun Apr 08 2001 - poeml@suse.de
- fix Requires (rearrange tags to define them before using them)
- fix spec file typo
* Tue Mar 27 2001 - rolf@suse.de
- spin off subpackage mod_php4-core which is required by apache and
  roxen modules now
- moved config file to /etc/php.ini for all php4 modules
- sybase support conflicts with Adabas D support
- Ingres support is for Ingres II only
- added t1lib support [BUG#6212]
- updated asp2php 0.75.13
- make us of suse_loadmodule for testing
- added /usr/bin/php to core package [BUG#6648]
* Wed Mar 21 2001 - ro@suse.de
- changed neededforbuild to freetype2
* Thu Mar 15 2001 - ro@suse.de
- build with openldap2
* Thu Mar 15 2001 - ro@suse.de
- fixed neededforbuild for openldap
* Mon Mar 05 2001 - ro@suse.de
- use -fPIC
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Fri Feb 23 2001 - ro@suse.de
- added readline/readline-devel to neededforbuild (split from bash)
* Thu Feb 15 2001 - rolf@suse.de
- new features imap-ssl, bz2, qtdom, ctype, debug, force-cgi-redirect,
  discard_path, sigchild, gd-imgstrttf
- added apache-mod_php4.rc.config
- added /etc/httpd/modules/mod_php4
* Wed Jan 17 2001 - rolf@suse.de
- add libpdf support
* Tue Jan 16 2001 - rolf@suse.de
- update to 4.0.4pl1 due to security issue [BUG#5760]
- remove number4.tar.gz, no longer needed
* Fri Jan 12 2001 - rolf@suse.de
- need expat to compile [BUG#5104]
- subpackage for roxen module
* Fri Jan 12 2001 - cihlar@suse.cz
- fixed to compile with roxe/pike [#4408]
* Tue Dec 19 2000 - rolf@suse.de
- link with libssl
* Tue Dec 19 2000 - rolf@suse.de
- added the asp2php package [BUG#4456]
- roxen/pike still doesnt work
- require RPM group tag via apxs
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <pg_lib> to <postgresql-lib>
* Mon Nov 27 2000 - rolf@suse.de
- added Sablotron support     [BUG#3891]
- added curl support          [BUG#3890]
- added Flash support on i386 [BUG#3209]
- also pack module files in /usr/lib/php/
- moved the exec dir to /usr/lib/php/bin
- include pear binaries
- added the following modules: sockets, shmop, exif, filepro, dbase
  readline, mcrypt, gettext
* Wed Nov 15 2000 - ro@suse.de
- fixed neededforbuild gdlib -> gd gd-devel
* Thu Nov 09 2000 - ro@suse.de
- prefer ndbm.h to db1/ndbm.h
* Mon Nov 06 2000 - ro@suse.de
- added imap-devel to neededforbuild
* Mon Nov 06 2000 - ro@suse.de
- fixed neededforbuild
* Mon Oct 16 2000 - bk@suse.de
- s390: --with-gd=yes -> --with-gd=shared(broken somehow with =yes)
* Mon Oct 16 2000 - rolf@suse.de
- update tp 4.0.3pl1 due to some security breaches
- needed to drop db3 and dbm support, as these are incompatible
- enable FTP support [BUG#3862]
* Wed Sep 13 2000 - fober@suse.de
- s390: suse_update_config, needs-not-forbuild adabas
* Fri Jul 07 2000 - kukuk@suse.de
- Fix Requires and need for build
* Fri Jun 23 2000 - rolf@suse.de
- added support for mcal and calendar functions [BUG#2925]
* Mon Jun 19 2000 - ro@suse.de
- fixed to compile with new postgres
* Mon May 22 2000 - rolf@suse.de
- update to 4.0.0
- --with-java is now broken
* Fri May 12 2000 - rolf@suse.de
- update to 4.0RC2
- a few more options are now functional
* Thu Apr 13 2000 - ro@suse.de
- added mm to neededforbuild
* Thu Mar 30 2000 - rolf@suse.de
- new version 4.0RC1
- many options now work properly
* Wed Mar 01 2000 - rolf@suse.de
- zlib works again
* Tue Feb 22 2000 - rolf@suse.de
- new version 4b4pl1
- now with --enable-thread-safety --with-gd=yes --with-ttf
- imap support is now broken
* Thu Dec 23 1999 - rolf@suse.de
- dynamic JDK path detection
- some fixes in DAV, still doesnt work
- now also runs with IMAP
* Thu Nov 25 1999 - rolf@suse.de
- initial package version 4.0b3
